

%Ye Li Chaofeng Sha Xin Huang Yanchun Zhang
%Community Detection in Attributed Graphs: An Embedding Approach
%AAAI-18


clear;
clc;

%% Test SCI on WebKB DataSet
% Edges  = 'citeseer.cites';
% Infos = 'citeseer.content';
%Edges  = 'wisconsin.cites';
%Infos = 'wisconsin.content';
% Edges  = 'washington.cites';
% Infos = 'washington.content';
% Edges  = 'texas.cites';
% Infos = 'texas.content';
% Edges  = 'cornell.cites';
% Infos = 'cornell.content';
%for NMF method
options = [];
options.maxIter = 200;
options.error = 1e-4;
options.nRepeat = 30;
options.minIter = 50;
options.meanFitRatio = 0.1;
options.rounds = 30;
options.kmeans = 1;

%testing on Wisconsin dataset
load myWisconsin.mat;
%K - Number of Communities
%gnd - groundtruth labels
%S - node attributes
%AdjMtx - adjacency matrix

NumOfNodes = size(AdjMtx,1);


kvac = [];
kvnmi = [];
%number of negative samples
parfor k = 1:30
A = createSPPMIMtx(AdjMtx,k);

    


%% Processing Iteration 
AClist = [];
NMIlist = [];
% 10 runs
for i = 1:10
disp(['iteration...',num2str(i)]);
disp('Initializing......');
U_ = [];
V_ = [];
% to guarantee the property that U is nonnegative
[U, V] = NMF(A, K, options, U_, V_);

%for our method
C = max(pinv(U)*S,0);
m = size(S, 2);

%for tesing the numbers of negative samples, we set alpha = belta = 1
%referencing 'Experiment-Parameter Sensitivity Analysis' section 
belta = 1;
alpha = 1;

disp('Computing......');
[Ucontent,C] = iterationNew(A,S,U,C,belta,alpha);
[U1max, U1index] = max(Ucontent,[],2);
U = Ucontent;

res = bestMap(gnd,U1index);
AC = length(find(gnd == res))/length(gnd);
NMI = compute_NMI(gnd, U1index);
       
AClist(i) = AC;
NMIlist(i) = NMI;
% fprintf('AC value: %f\n', AC);
% fprintf('NMI value: %f\n', NMI);
end
% AClist
% NMIlist
kvac(k) = mean(AClist);
kvnmi(k) = mean(NMIlist);
end
%the results mentioned in our paper is that we tested CDE on Wisconsin by varying 
%parameter  from 1 to 100. Fig.2 shows CDE achieves better performances in
%the range of  = 22 through  = 29. Specifically, CDE achieves the 
%maximum scores of AC = 0.6645 and N M I = 0.409 when  = 25.
%For the demo, I runed the script again and stored the results in
%testResult.mat. You could load it and have a look.
max(kvac)
max(kvnmi)

%save testResult.mat kvac kvnmi

 



